Ext JS 4.1.3 Sencha Docs

Ext.data.proxy.Rest

Alternate names

Ext.data.RestProxy

Hierarchy

Inherited mixins

Files

The Rest proxy is a specialization of the AjaxProxy which simply maps the four actions (create, read, update and destroy) to RESTful HTTP verbs. For example, let's set up a Model with an inline Rest proxy

Ext.define('User', {
    extend: 'Ext.data.Model',
    fields: ['id', 'name', 'email'],

    proxy: {
        type: 'rest',
        url : '/users'
    }
});

Now we can create a new User instance and save it via the Rest proxy. Doing this will cause the Proxy to send a POST request to '/users':

var user = Ext.create('User', {name: 'Ed Spencer', email: 'ed@sencha.com'});

user.save(); //POST /users

Let's expand this a little and provide a callback for the Ext.data.Model.save call to update the Model once it has been created. We'll assume the creation went successfully and that the server gave this user an ID of 123:

user.save({
    success: function(user) {
        user.set('name', 'Khan Noonien Singh');

        user.save(); //PUT /users/123
    }
});

Now that we're no longer creating a new Model instance, the request method is changed to an HTTP PUT, targeting the relevant url for that user. Now let's delete this user, which will use the DELETE method:

    user.destroy(); //DELETE /users/123

Finally, when we perform a load of a Model or Store, Rest proxy will use the GET method:

//1. Load via Store

//the Store automatically picks up the Proxy from the User model
var store = Ext.create('Ext.data.Store', {
    model: 'User'
});

store.load(); //GET /users

//2. Load directly from the Model

//GET /users/123
Ext.ModelManager.getModel('User').load(123, {
    success: function(user) {
        console.log(user.getId()); //outputs 123
    }
});

Url generation

The Rest proxy is able to automatically generate the urls above based on two configuration options - appendId and format. If appendId is true (it is by default) then Rest proxy will automatically append the ID of the Model instance in question to the configured url, resulting in the '/users/123' that we saw above.

If the request is not for a specific Model instance (e.g. loading a Store), the url is not appended with an id. The Rest proxy will automatically insert a '/' before the ID if one is not already present.

new Ext.data.proxy.Rest({
    url: '/users',
    appendId: true //default
});

// Collection url: /users
// Instance url  : /users/123

The Rest proxy can also optionally append a format string to the end of any generated url:

new Ext.data.proxy.Rest({
    url: '/users',
    format: 'json'
});

// Collection url: /users.json
// Instance url  : /users/123.json

If further customization is needed, simply implement the buildUrl method and add your custom generated url onto the Request object that is passed to buildUrl. See Rest proxy's implementation for an example of how to achieve this.

Note that Rest proxy inherits from AjaxProxy, which already injects all of the sorter, filter, group and paging options into the generated url. See the AjaxProxy docs for more details.

Available since: 4.0.0

Defined By

Config options

Specific urls to call on CRUD action methods "create", "read", "update" and "destroy". ...

Specific urls to call on CRUD action methods "create", "read", "update" and "destroy". Defaults to:

api: {
    create  : undefined,
    read    : undefined,
    update  : undefined,
    destroy : undefined
}

The url is built based upon the action being executed [create|read|update|destroy] using the commensurate api property, or if undefined default to the configured Ext.data.Store.url.

For example:

api: {
    create  : '/controller/new',
    read    : '/controller/load',
    update  : '/controller/update',
    destroy : '/controller/destroy_action'
}

If the specific URL for a given CRUD action is undefined, the CRUD action request will be directed to the configured url.

Available since: 4.0.0

Ext.data.proxy.Rest
view source
: Boolean
True to automatically append the ID of a Model instance when performing a request based on that single instance. ...

True to automatically append the ID of a Model instance when performing a request based on that single instance. See Rest proxy intro docs for more details. Defaults to true.

Defaults to: true

Available since: 4.0.0

Ext.data.proxy.Rest
view source
: Boolean
True to batch actions of a particular type when synchronizing the store. ...

True to batch actions of a particular type when synchronizing the store. Defaults to false.

Defaults to: false

Available since: 4.0.0

Overrides: Ext.data.proxy.Proxy.batchActions

Comma-separated ordering 'create', 'update' and 'destroy' actions when batching. ...

Comma-separated ordering 'create', 'update' and 'destroy' actions when batching. Override this to set a different order for the batched CRUD actions to be executed in. Defaults to 'create,update,destroy'.

Defaults to: 'create,update,destroy'

Available since: 4.0.0

True to request binary data from the server. ...

True to request binary data from the server. This feature requires the use of a binary reader such as AMF Reader

Defaults to: false

Available since: 4.1.2

The name of the cache param added to the url when using noCache. ...

The name of the cache param added to the url when using noCache. Defaults to "_dc".

Defaults to: "_dc"

Available since: 4.0.0

The default registered reader type. ...

The default registered reader type. Defaults to 'json'.

Defaults to: 'json'

Available since: 4.0.0

The default registered writer type. ...

The default registered writer type. Defaults to 'json'.

Defaults to: 'json'

Available since: 4.0.0

The name of the direction parameter to send in a request. ...

The name of the direction parameter to send in a request. This is only used when simpleSortMode is set to true.

Defaults to: "dir"

Available since: 4.0.0

Extra parameters that will be included on every request. ...

Extra parameters that will be included on every request. Individual requests with params of the same name will override these params when they are in conflict.

Available since: 4.0.0

The name of the 'filter' parameter to send in a request. ...

The name of the 'filter' parameter to send in a request. Defaults to 'filter'. Set this to undefined if you don't want to send a filter parameter.

Defaults to: "filter"

Available since: 4.0.0

Ext.data.proxy.Rest
view source
: String
Optional data format to send to the server when making any request (e.g. ...

Optional data format to send to the server when making any request (e.g. 'json'). See the Rest proxy intro docs for full details. Defaults to undefined.

Available since: 4.0.0

The name of the direction parameter to send in a request. ...

The name of the direction parameter to send in a request. This is only used when simpleGroupMode is set to true.

Defaults to: "groupDir"

Available since: 4.1.1

The name of the 'group' parameter to send in a request. ...

The name of the 'group' parameter to send in a request. Defaults to 'group'. Set this to undefined if you don't want to send a group parameter.

Defaults to: "group"

Available since: 4.0.0

Any headers to add to the Ajax request. ...

Any headers to add to the Ajax request. Defaults to undefined.

Available since: 4.0.0

The name of the parameter which carries the id of the entity being operated upon. ...

The name of the parameter which carries the id of the entity being operated upon.

Defaults to: "id"

Available since: 4.1.2

The name of the 'limit' parameter to send in a request. ...

The name of the 'limit' parameter to send in a request. Defaults to 'limit'. Set this to undefined if you don't want to send a limit parameter.

Defaults to: "limit"

Available since: 4.0.0

A config object containing one or more event handlers to be added to this object during initialization. ...

A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once.

DOM events from Ext JS Components

While some Ext JS Component classes export selected DOM events (e.g. "click", "mouseover" etc), this is usually only done when extra value can be added. For example the DataView's itemclick event passing the node clicked on. To access DOM events directly from a child element of a Component, we need to specify the element option to identify the Component property to add a DOM listener to:

new Ext.panel.Panel({
    width: 400,
    height: 200,
    dockedItems: [{
        xtype: 'toolbar'
    }],
    listeners: {
        click: {
            element: 'el', //bind to the underlying el property on the panel
            fn: function(){ console.log('click el'); }
        },
        dblclick: {
            element: 'body', //bind to the underlying body property on the panel
            fn: function(){ console.log('dblclick body'); }
        }
    }
});

Available since: 1.1.0

The name of the Model to tie to this Proxy. ...

The name of the Model to tie to this Proxy. Can be either the string name of the Model, or a reference to the Model constructor. Required.

Available since: 4.0.0

Disable caching by adding a unique parameter name to the request. ...

Disable caching by adding a unique parameter name to the request. Set to false to allow caching. Defaults to true.

Defaults to: true

Available since: 4.0.0

The name of the 'page' parameter to send in a request. ...

The name of the 'page' parameter to send in a request. Defaults to 'page'. Set this to undefined if you don't want to send a page parameter.

Defaults to: "page"

Available since: 4.0.0

The Ext.data.reader.Reader to use to decode the server's response or data read from client. ...

The Ext.data.reader.Reader to use to decode the server's response or data read from client. This can either be a Reader instance, a config object or just a valid Reader type name (e.g. 'json', 'xml').

Available since: 4.0.4

Enabling simpleGroupMode in conjunction with remoteGroup will only send one group property and a direction when a rem...

Enabling simpleGroupMode in conjunction with remoteGroup will only send one group property and a direction when a remote group is requested. The groupDirectionParam and groupParam will be sent with the property name and either 'ASC' or 'DESC'.

Defaults to: false

Available since: 4.1.1

Enabling simpleSortMode in conjunction with remoteSort will only send one sort property and a direction when a remote...

Enabling simpleSortMode in conjunction with remoteSort will only send one sort property and a direction when a remote sort is requested. The directionParam and sortParam will be sent with the property name and either 'ASC' or 'DESC'.

Defaults to: false

Available since: 4.0.0

The name of the 'sort' parameter to send in a request. ...

The name of the 'sort' parameter to send in a request. Defaults to 'sort'. Set this to undefined if you don't want to send a sort parameter.

Defaults to: "sort"

Available since: 4.0.0

The name of the 'start' parameter to send in a request. ...

The name of the 'start' parameter to send in a request. Defaults to 'start'. Set this to undefined if you don't want to send a start parameter.

Defaults to: "start"

Available since: 4.0.0

The number of milliseconds to wait for a response. ...

The number of milliseconds to wait for a response. Defaults to 30000 milliseconds (30 seconds).

Defaults to: 30000

Available since: 4.0.0

The URL from which to request the data object.

The URL from which to request the data object.

Available since: 4.0.0

The Ext.data.writer.Writer to use to encode any request sent to the server or saved to client. ...

The Ext.data.writer.Writer to use to encode any request sent to the server or saved to client. This can either be a Writer instance, a config object or just a valid Writer type name (e.g. 'json', 'xml').

Available since: 4.0.4

Properties

Defined By

Instance Properties

...

Defaults to: 'Ext.Base'

Available since: 4.1.1

Ext.data.proxy.Rest
view source
: Object
Mapping of action name to HTTP request method. ...

Mapping of action name to HTTP request method. These default to RESTful conventions for the 'create', 'read', 'update' and 'destroy' actions (which map to 'POST', 'GET', 'PUT' and 'DELETE' respectively). This object should not be changed except globally via Ext.override - the getMethod function can be overridden instead.

Defaults to: {create: 'POST', read: 'GET', update: 'PUT', destroy: 'DELETE'}

Available since: 4.0.0

Overrides: Ext.data.proxy.Ajax.actionMethods

...

Defaults to: {}

Available since: 4.1.1

Initial suspended call count. ...

Initial suspended call count. Incremented when suspendEvents is called, decremented when resumeEvents is called.

Defaults to: 0

Available since: 4.1.1

This object holds a key for any event that has a listener. ...

This object holds a key for any event that has a listener. The listener may be set directly on the instance, or on its class or a super class (via observe) or on the MVC EventBus. The values of this object are truthy (a non-zero number) and falsy (0 or undefined). They do not represent an exact count of listeners. The value for an event is truthy if the event must be fired and is falsy if there is no need to fire the event.

The intended use of this property is to avoid the expense of fireEvent calls when there are no listeners. This can be particularly helpful when one would otherwise have to call fireEvent hundreds or thousands of times. It is used like this:

 if (this.hasListeners.foo) {
     this.fireEvent('foo', this, arg1);
 }

Available since: 4.1.0

...

Defaults to: []

Available since: 4.1.1

...

Defaults to: {}

Available since: 4.1.1

...

Defaults to: true

Available since: 4.1.1

true in this class to identify an object as an instantiated Observable, or subclass thereof. ...

true in this class to identify an object as an instantiated Observable, or subclass thereof.

Defaults to: true

Available since: 4.0.0

true in this class to identify an object as an instantiated Proxy, or subclass thereof. ...

true in this class to identify an object as an instantiated Proxy, or subclass thereof.

Defaults to: true

Available since: 4.1.0

Get the reference to the current class from which this object was instantiated. ...

Get the reference to the current class from which this object was instantiated. Unlike statics, this.self is scope-dependent and it's meant to be used for dynamic inheritance. See statics for a detailed comparison

Ext.define('My.Cat', {
    statics: {
        speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
    },

    constructor: function() {
        alert(this.self.speciesName); // dependent on 'this'
    },

    clone: function() {
        return new this.self();
    }
});


Ext.define('My.SnowLeopard', {
    extend: 'My.Cat',
    statics: {
        speciesName: 'Snow Leopard'         // My.SnowLeopard.speciesName = 'Snow Leopard'
    }
});

var cat = new My.Cat();                     // alerts 'Cat'
var snowLeopard = new My.SnowLeopard();     // alerts 'Snow Leopard'

var clone = snowLeopard.clone();
alert(Ext.getClassName(clone));             // alerts 'My.SnowLeopard'

Available since: 4.0.0

Defined By

Static Properties

...

Defaults to: []

Available since: 4.1.1

Methods

Defined By

Instance Methods

Note that if this HttpProxy is being used by a Store, then the Store's call to load will override any specified callb...

Note that if this HttpProxy is being used by a Store, then the Store's call to load will override any specified callback and params options. In this case, use the Store's events to modify parameters, or react to loading events.

Available since: 1.1.0

Parameters

  • config : Object (optional)

    Config object. If an options parameter is passed, the singleton Ext.Ajax object will be used to make the request.

Returns

Overrides: Ext.data.proxy.Proxy.constructor

Adds the specified events to the list of events which this Observable may fire. ...

Adds the specified events to the list of events which this Observable may fire.

Available since: 1.1.0

Parameters

  • eventNames : Object/String...

    Either an object with event names as properties with a value of true. For example:

    this.addEvents({
        storeloaded: true,
        storecleared: true
    });
    

    Or any number of event names as separate parameters. For example:

    this.addEvents('storeloaded', 'storecleared');
    
( eventName, [fn], [scope], [options] ) : Object
Appends an event handler to this object. ...

Appends an event handler to this object. For example:

myGridPanel.on("mouseover", this.onMouseOver, this);

The method also allows for a single argument to be passed which is a config object containing properties which specify multiple events. For example:

myGridPanel.on({
    cellClick: this.onCellClick,
    mouseover: this.onMouseOver,
    mouseout: this.onMouseOut,
    scope: this // Important. Ensure "this" is correct during handler execution
});

One can also specify options for each event handler separately:

myGridPanel.on({
    cellClick: {fn: this.onCellClick, scope: this, single: true},
    mouseover: {fn: panel.onMouseOver, scope: panel}
});

Names of methods in a specified scope may also be used. Note that scope MUST be specified to use this option:

myGridPanel.on({
    cellClick: {fn: 'onCellClick', scope: this, single: true},
    mouseover: {fn: 'onMouseOver', scope: panel}
});

Available since: 1.1.0

Parameters

  • eventName : String/Object

    The name of the event to listen for. May also be an object who's property names are event names.

  • fn : Function (optional)

    The method the event invokes, or if scope is specified, the name* of the method within the specified scope. Will be called with arguments given to fireEvent plus the options parameter described below.

  • scope : Object (optional)

    The scope (this reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.

  • options : Object (optional)

    An object containing handler configuration.

    Note: Unlike in ExtJS 3.x, the options object will also be passed as the last argument to every event handler.

    This object may contain any of the following properties:

    • scope : Object

      The scope (this reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.

    • delay : Number

      The number of milliseconds to delay the invocation of the handler after the event fires.

    • single : Boolean

      True to add a handler to handle just the next firing of the event, and then remove itself.

    • buffer : Number

      Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.

    • target : Ext.util.Observable

      Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a child Observable.

    • element : String

      This option is only valid for listeners bound to Components. The name of a Component property which references an element to add a listener to.

      This option is useful during Component construction to add DOM event listeners to elements of Components which will exist only after the Component is rendered. For example, to add a click listener to a Panel's body:

        new Ext.panel.Panel({
            title: 'The title',
            listeners: {
                click: this.handlePanelClick,
                element: 'body'
            }
        });
      
    • destroyable : Boolean (optional)

      When specified as true, the function returns A Destroyable object. An object which implements the destroy method which removes all listeners added in this call.

      Combining Options

      Using the options argument, it is possible to combine different types of listeners:

      A delayed, one-time listener.

      myPanel.on('hide', this.handleClick, this, {
          single: true,
          delay: 100
      });
      

      Defaults to: false

Returns

  • Object

    Only when the destroyable option is specified.

    A Destroyable object. An object which implements the destroy method which removes all listeners added in this call. For example:

    this.btnListeners =  = myButton.on({
        destroyable: true
        mouseover:   function() { console.log('mouseover'); },
        mouseout:    function() { console.log('mouseout'); },
        click:       function() { console.log('click'); }
    });
    

    And when those listeners need to be removed:

    Ext.destroy(this.btnListeners);
    

    or

    this.btnListeners.destroy();
    

Overrides: Ext.AbstractComponent.addListener

( item, ename, [fn], [scope], [options] ) : Object
Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is destr...

Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is destroyed.

Available since: 4.0.0

Parameters

  • item : Ext.util.Observable/Ext.Element

    The item to which to add a listener/listeners.

  • ename : Object/String

    The event name, or an object containing event name properties.

  • fn : Function (optional)

    If the ename parameter was an event name, this is the handler function.

  • scope : Object (optional)

    If the ename parameter was an event name, this is the scope (this reference) in which the handler function is executed.

  • options : Object (optional)

    If the ename parameter was an event name, this is the addListener options.

Returns

  • Object

    Only when the destroyable option is specified.

    A Destroyable object. An object which implements the destroy method which removes all listeners added in this call. For example:

    this.btnListeners =  = myButton.mon({
        destroyable: true
        mouseover:   function() { console.log('mouseover'); },
        mouseout:    function() { console.log('mouseout'); },
        click:       function() { console.log('click'); }
    });
    

    And when those listeners need to be removed:

    Ext.destroy(this.btnListeners);
    

    or

    this.btnListeners.destroy();
    
( request, success )protectedtemplate
Optional callback function which can be used to clean up after a request has been completed. ...

Optional callback function which can be used to clean up after a request has been completed.

Available since: 4.0.0

This is a template method. a hook into the functionality of this class. Feel free to override it in child classes.

Parameters

Encode any values being sent to the server. ...

Encode any values being sent to the server. Can be overridden in subclasses.

Available since: 4.0.0

Parameters

  • An : Array

    array of sorters/filters.

Returns

Performs a batch of Operations, in the order specified by batchOrder. ...

Performs a batch of Operations, in the order specified by batchOrder. Used internally by Ext.data.Store's sync method. Example usage:

myProxy.batch({
    create : [myModel1, myModel2],
    update : [myModel3],
    destroy: [myModel4, myModel5]
});

Where the myModel* above are Model instances - in this case 1 and 2 are new instances and have not been saved before, 3 has been saved previously but needs to be updated, and 4 and 5 have already been saved but should now be destroyed.

Note that the previous version of this method took 2 arguments (operations and listeners). While this is still supported for now, the current signature is now a single options argument that can contain both operations and listeners, in addition to other options. The multi-argument signature will likely be deprecated in a future release.

Available since: 4.0.0

Parameters

  • options : Object

    Object containing one or more properties supported by the batch method:

    • operations : Object

      Object containing the Model instances to act upon, keyed by action name

    • listeners : Object (optional)

      Event listeners object passed straight through to the Batch - see Ext.data.Batch for details

    • batch : Ext.data.Batch/Object (optional)

      A Ext.data.Batch object (or batch config to apply to the created batch). If unspecified a default batch will be auto-created.

    • callback : Function (optional)

      The function to be called upon completion of processing the batch. The callback is called regardless of success or failure and is passed the following parameters:

      Parameters

      • batch : Ext.data.Batch

        The batch that was processed, containing all operations in their current state after processing

      • options : Object

        The options argument that was originally passed into batch

    • success : Function (optional)

      The function to be called upon successful completion of the batch. The success function is called only if no exceptions were reported in any operations. If one or more exceptions occurred then the failure function will be called instead. The success function is called with the following parameters:

      Parameters

      • batch : Ext.data.Batch

        The batch that was processed, containing all operations in their current state after processing

      • options : Object

        The options argument that was originally passed into batch

    • failure : Function (optional)

      The function to be called upon unsuccessful completion of the batch. The failure function is called when one or more operations returns an exception during processing (even if some operations were also successful). In this case you can check the batch's exceptions array to see exactly which operations had exceptions. The failure function is called with the following parameters:

      Parameters

      • batch : Ext.data.Batch

        The batch that was processed, containing all operations in their current state after processing

      • options : Object

        The options argument that was originally passed into batch

    • scope : Object (optional)

      The scope in which to execute any callbacks (i.e. the this object inside the callback, success and/or failure functions). Defaults to the proxy.

Returns

Creates an Request object from Operation. ...

Creates an Request object from Operation.

This gets called from doRequest methods in subclasses of Server proxy.

Available since: 4.0.0

Parameters

Returns

Ext.data.proxy.Rest
view source
( request )
Specialized version of buildUrl that incorporates the appendId and format options into the generated url. ...

Specialized version of buildUrl that incorporates the appendId and format options into the generated url. Override this to provide further customizations, but remember to call the superclass buildUrl so that additional parameters like the cache buster string are appended.

Available since: 4.0.0

Parameters

Overrides: Ext.data.proxy.Server.buildUrl

( args ) : Objectdeprecatedprotected
Call the original method that was previously overridden with override Ext.define('My.Cat', { constructor: functi...

Call the original method that was previously overridden with override

Ext.define('My.Cat', {
    constructor: function() {
        alert("I'm a cat!");
    }
});

My.Cat.override({
    constructor: function() {
        alert("I'm going to be a cat!");

        this.callOverridden();

        alert("Meeeeoooowwww");
    }
});

var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
                          // alerts "I'm a cat!"
                          // alerts "Meeeeoooowwww"

This method has been deprecated

as of 4.1. Use callParent instead.

Available since: 4.0.0

Parameters

  • args : Array/Arguments

    The arguments, either an array or the arguments object from the current method, for example: this.callOverridden(arguments)

Returns

  • Object

    Returns the result of calling the overridden method

Call the "parent" method of the current method. ...

Call the "parent" method of the current method. That is the method previously overridden by derivation or by an override (see Ext.define).

 Ext.define('My.Base', {
     constructor: function (x) {
         this.x = x;
     },

     statics: {
         method: function (x) {
             return x;
         }
     }
 });

 Ext.define('My.Derived', {
     extend: 'My.Base',

     constructor: function () {
         this.callParent([21]);
     }
 });

 var obj = new My.Derived();

 alert(obj.x);  // alerts 21

This can be used with an override as follows:

 Ext.define('My.DerivedOverride', {
     override: 'My.Derived',

     constructor: function (x) {
         this.callParent([x*2]); // calls original My.Derived constructor
     }
 });

 var obj = new My.Derived();

 alert(obj.x);  // now alerts 42

This also works with static methods.

 Ext.define('My.Derived2', {
     extend: 'My.Base',

     statics: {
         method: function (x) {
             return this.callParent([x*2]); // calls My.Base.method
         }
     }
 });

 alert(My.Base.method(10);     // alerts 10
 alert(My.Derived2.method(10); // alerts 20

Lastly, it also works with overridden static methods.

 Ext.define('My.Derived2Override', {
     override: 'My.Derived2',

     statics: {
         method: function (x) {
             return this.callParent([x*2]); // calls My.Derived2.method
         }
     }
 });

 alert(My.Derived2.method(10); // now alerts 40

To override a method and replace it and also call the superclass method, use callSuper. This is often done to patch a method to fix a bug.

Available since: 4.0.0

Parameters

  • args : Array/Arguments

    The arguments, either an array or the arguments object from the current method, for example: this.callParent(arguments)

Returns

  • Object

    Returns the result of calling the parent method

( args ) : Objectprotected
This method is used by an override to call the superclass method but bypass any overridden method. ...

This method is used by an override to call the superclass method but bypass any overridden method. This is often done to "patch" a method that contains a bug but for whatever reason cannot be fixed directly.

Consider:

 Ext.define('Ext.some.Class', {
     method: function () {
         console.log('Good');
     }
 });

 Ext.define('Ext.some.DerivedClass', {
     method: function () {
         console.log('Bad');

         // ... logic but with a bug ...

         this.callParent();
     }
 });

To patch the bug in DerivedClass.method, the typical solution is to create an override:

 Ext.define('App.paches.DerivedClass', {
     override: 'Ext.some.DerivedClass',

     method: function () {
         console.log('Fixed');

         // ... logic but with bug fixed ...

         this.callSuper();
     }
 });

The patch method cannot use callParent to call the superclass method since that would call the overridden method containing the bug. In other words, the above patch would only produce "Fixed" then "Good" in the console log, whereas, using callParent would produce "Fixed" then "Bad" then "Good".

Available since: Ext JS 4.1.3

Parameters

  • args : Array/Arguments

    The arguments, either an array or the arguments object from the current method, for example: this.callSuper(arguments)

Returns

  • Object

    Returns the result of calling the superclass method

Removes all listeners for this object including the managed listeners ...

Removes all listeners for this object including the managed listeners

Available since: 4.0.0

Removes all managed listeners for this object. ...

Removes all managed listeners for this object.

Available since: 4.0.0

...

Available since: 4.1.1

( eventName, args, bubbles )private
Continue to fire event. ...

Continue to fire event.

Available since: 4.0.7

Parameters

( operation, callback, scope )
in a ServerProxy all four CRUD operations are executed in the same manner, so we delegate to doRequest in each case ...

in a ServerProxy all four CRUD operations are executed in the same manner, so we delegate to doRequest in each case

Performs the given create operation.

Available since: 4.0.0

Parameters

  • operation : Ext.data.Operation

    The Operation to perform

  • callback : Function

    Callback function to be called when the Operation has completed (whether successful or not)

  • scope : Object

    Scope to execute the callback function in

Overrides: Ext.data.proxy.Proxy.create

Creates an event handling function which refires the event from this object as the passed event name. ...

Creates an event handling function which refires the event from this object as the passed event name.

Available since: 4.0.0

Parameters

  • newName : Object
  • beginEnd : Array (optional)

    The caller can specify on which indices to slice

Returns

( request, operation, callback, scope ) : Functionprivate
TODO: This is currently identical to the JsonPProxy version except for the return function's signature. ...

TODO: This is currently identical to the JsonPProxy version except for the return function's signature. There is a lot of code duplication inside the returned function so we need to find a way to DRY this up.

Available since: 4.0.0

Parameters

  • request : Ext.data.Request

    The Request object

  • operation : Ext.data.Operation

    The Operation being executed

  • callback : Function

    The callback function to be called when the request completes. This is usually the callback passed to doRequest

  • scope : Object

    The scope in which to execute the callback function

Returns

( operation, callback, scope )
Performs the given destroy operation. ...

Performs the given destroy operation.

Available since: 4.0.0

Parameters

  • operation : Ext.data.Operation

    The Operation to perform

  • callback : Function

    Callback function to be called when the Operation has completed (whether successful or not)

  • scope : Object

    Scope to execute the callback function in

Overrides: Ext.data.proxy.Proxy.destroy

( operation, callback, scope )
In ServerProxy subclasses, the create, read, update and destroy methods all pass through to doRequest. ...

In ServerProxy subclasses, the create, read, update and destroy methods all pass through to doRequest. Each ServerProxy subclass must implement the doRequest method - see Ext.data.proxy.JsonP and Ext.data.proxy.Ajax for examples. This method carries the same signature as each of the methods that delegate to it.

Available since: 4.0.0

Parameters

Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if present. ...

Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if present. There is no implementation in the Observable base class.

This is commonly used by Ext.Components to bubble events to owner Containers. See Ext.Component.getBubbleTarget. The default implementation in Ext.Component returns the Component's immediate owner. But if a known target is required, this can be overridden to access the required target more quickly.

Example:

Ext.define('Ext.overrides.form.field.Base', {
    override: 'Ext.form.field.Base',

    //  Add functionality to Field's initComponent to enable the change event to bubble
    initComponent: function () {
        this.callParent();
        this.enableBubble('change');
    }
});

var myForm = Ext.create('Ext.form.Panel', {
    title: 'User Details',
    items: [{
        ...
    }],
    listeners: {
        change: function() {
            // Title goes red if form has been modified.
            myForm.header.setStyle('color', 'red');
        }
    }
});

Available since: 3.4.0

Parameters

  • eventNames : String/String[]

    The event name to bubble, or an Array of event names.

Encodes the array of Ext.util.Filter objects into a string to be sent in the request url. ...

Encodes the array of Ext.util.Filter objects into a string to be sent in the request url. By default, this simply JSON-encodes the filter data

Available since: 4.0.0

Parameters

Returns

Encodes the array of Ext.util.Sorter objects into a string to be sent in the request url. ...

Encodes the array of Ext.util.Sorter objects into a string to be sent in the request url. By default, this simply JSON-encodes the sorter data

Available since: 4.0.0

Parameters

Returns

Template method to allow subclasses to specify how to get the response for the reader. ...

Template method to allow subclasses to specify how to get the response for the reader.

Available since: 4.0.0

This is a template method. a hook into the functionality of this class. Feel free to override it in child classes.

Parameters

  • response : Object

    The server response

Returns

  • Object

    The response data to be used by the reader

Fires the specified event with the passed parameters (minus the event name, plus the options object passed to addList...

Fires the specified event with the passed parameters (minus the event name, plus the options object passed to addListener).

An event may be set to bubble up an Observable parent hierarchy (See Ext.Component.getBubbleTarget) by calling enableBubble.

Available since: 1.1.0

Parameters

  • eventName : String

    The name of the event to fire.

  • args : Object...

    Variable number of parameters are passed to handlers.

Returns

  • Boolean

    returns false if any of the handlers return false otherwise it returns true.

Gets the bubbling parent for an Observable ...

Gets the bubbling parent for an Observable

Available since: 4.0.7

Returns

...

Available since: 4.1.0

Parameters

Returns the initial configuration passed to constructor when instantiating this class. ...

Returns the initial configuration passed to constructor when instantiating this class.

Available since: 4.1.0

Parameters

  • name : String (optional)

    Name of the config option to return.

Returns

  • Object/Mixed

    The full config object or a single config value when name parameter specified.

Returns the HTTP method name for a given request. ...

Returns the HTTP method name for a given request. By default this returns based on a lookup on actionMethods.

Available since: 4.0.0

Parameters

Returns

  • String

    The HTTP method to use (should be one of 'GET', 'POST', 'PUT' or 'DELETE')

Returns the model attached to this Proxy ...

Returns the model attached to this Proxy

Available since: 4.0.0

Returns

Copy any sorters, filters etc into the params so they can be sent over the wire ...

Copy any sorters, filters etc into the params so they can be sent over the wire

Available since: 4.0.0

Parameters

Returns the reader currently attached to this proxy instance ...

Returns the reader currently attached to this proxy instance

Available since: 4.0.0

Returns

Get the url for the request taking into account the order of priority, - The request - The api - The url ...

Get the url for the request taking into account the order of priority, - The request - The api - The url

Available since: 4.0.0

Parameters

Returns

Returns the writer currently attached to this proxy instance ...

Returns the writer currently attached to this proxy instance

Available since: 4.0.0

Returns

...

Available since: 4.1.0

Parameters

Checks to see if this object has any listeners for a specified event, or whether the event bubbles. ...

Checks to see if this object has any listeners for a specified event, or whether the event bubbles. The answer indicates whether the event needs firing or not.

Available since: 1.1.0

Parameters

  • eventName : String

    The name of the event to check for

Returns

  • Boolean

    true if the event is being listened for or bubbles, else false

( config ) : Ext.Basechainableprotected
Initialize configuration for this class. ...

Initialize configuration for this class. a typical example:

Ext.define('My.awesome.Class', {
    // The default config
    config: {
        name: 'Awesome',
        isAwesome: true
    },

    constructor: function(config) {
        this.initConfig(config);
    }
});

var awesome = new My.awesome.Class({
    name: 'Super Awesome'
});

alert(awesome.getName()); // 'Super Awesome'

Available since: 4.0.0

Parameters

Returns

( item, ename, [fn], [scope], [options] ) : Object
Shorthand for addManagedListener. ...

Shorthand for addManagedListener.

Adds listeners to any Observable object (or Ext.Element) which are automatically removed when this Component is destroyed.

Available since: 4.0.2

Parameters

  • item : Ext.util.Observable/Ext.Element

    The item to which to add a listener/listeners.

  • ename : Object/String

    The event name, or an object containing event name properties.

  • fn : Function (optional)

    If the ename parameter was an event name, this is the handler function.

  • scope : Object (optional)

    If the ename parameter was an event name, this is the scope (this reference) in which the handler function is executed.

  • options : Object (optional)

    If the ename parameter was an event name, this is the addListener options.

Returns

  • Object

    Only when the destroyable option is specified.

    A Destroyable object. An object which implements the destroy method which removes all listeners added in this call. For example:

    this.btnListeners =  = myButton.mon({
        destroyable: true
        mouseover:   function() { console.log('mouseover'); },
        mouseout:    function() { console.log('mouseout'); },
        click:       function() { console.log('click'); }
    });
    

    And when those listeners need to be removed:

    Ext.destroy(this.btnListeners);
    

    or

    this.btnListeners.destroy();
    
( item, ename, [fn], [scope] )
Shorthand for removeManagedListener. ...

Shorthand for removeManagedListener.

Removes listeners that were added by the mon method.

Available since: 4.0.2

Parameters

  • item : Ext.util.Observable/Ext.Element

    The item from which to remove a listener/listeners.

  • ename : Object/String

    The event name, or an object containing event name properties.

  • fn : Function (optional)

    If the ename parameter was an event name, this is the handler function.

  • scope : Object (optional)

    If the ename parameter was an event name, this is the scope (this reference) in which the handler function is executed.

( eventName, [fn], [scope], [options] ) : Object
Shorthand for addListener. ...

Shorthand for addListener.

Appends an event handler to this object. For example:

myGridPanel.on("mouseover", this.onMouseOver, this);

The method also allows for a single argument to be passed which is a config object containing properties which specify multiple events. For example:

myGridPanel.on({
    cellClick: this.onCellClick,
    mouseover: this.onMouseOver,
    mouseout: this.onMouseOut,
    scope: this // Important. Ensure "this" is correct during handler execution
});

One can also specify options for each event handler separately:

myGridPanel.on({
    cellClick: {fn: this.onCellClick, scope: this, single: true},
    mouseover: {fn: panel.onMouseOver, scope: panel}
});

Names of methods in a specified scope may also be used. Note that scope MUST be specified to use this option:

myGridPanel.on({
    cellClick: {fn: 'onCellClick', scope: this, single: true},
    mouseover: {fn: 'onMouseOver', scope: panel}
});

Available since: 1.1.0

Parameters

  • eventName : String/Object

    The name of the event to listen for. May also be an object who's property names are event names.

  • fn : Function (optional)

    The method the event invokes, or if scope is specified, the name* of the method within the specified scope. Will be called with arguments given to fireEvent plus the options parameter described below.

  • scope : Object (optional)

    The scope (this reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.

  • options : Object (optional)

    An object containing handler configuration.

    Note: Unlike in ExtJS 3.x, the options object will also be passed as the last argument to every event handler.

    This object may contain any of the following properties:

    • scope : Object

      The scope (this reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.

    • delay : Number

      The number of milliseconds to delay the invocation of the handler after the event fires.

    • single : Boolean

      True to add a handler to handle just the next firing of the event, and then remove itself.

    • buffer : Number

      Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.

    • target : Ext.util.Observable

      Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a child Observable.

    • element : String

      This option is only valid for listeners bound to Components. The name of a Component property which references an element to add a listener to.

      This option is useful during Component construction to add DOM event listeners to elements of Components which will exist only after the Component is rendered. For example, to add a click listener to a Panel's body:

        new Ext.panel.Panel({
            title: 'The title',
            listeners: {
                click: this.handlePanelClick,
                element: 'body'
            }
        });
      
    • destroyable : Boolean (optional)

      When specified as true, the function returns A Destroyable object. An object which implements the destroy method which removes all listeners added in this call.

      Combining Options

      Using the options argument, it is possible to combine different types of listeners:

      A delayed, one-time listener.

      myPanel.on('hide', this.handleClick, this, {
          single: true,
          delay: 100
      });
      

      Defaults to: false

Returns

  • Object

    Only when the destroyable option is specified.

    A Destroyable object. An object which implements the destroy method which removes all listeners added in this call. For example:

    this.btnListeners =  = myButton.on({
        destroyable: true
        mouseover:   function() { console.log('mouseover'); },
        mouseout:    function() { console.log('mouseout'); },
        click:       function() { console.log('click'); }
    });
    

    And when those listeners need to be removed:

    Ext.destroy(this.btnListeners);
    

    or

    this.btnListeners.destroy();
    
The internal callback that the proxy uses to call any specified user callbacks after completion of a batch ...

The internal callback that the proxy uses to call any specified user callbacks after completion of a batch

Available since: 4.1.0

Parameters

( names, callback, scope )private
...

Available since: 4.1.0

Parameters

...

Available since: 4.0.0

Called each time the reader's onMetaChange is called so that the proxy can fire the metachange event ...

Called each time the reader's onMetaChange is called so that the proxy can fire the metachange event

Available since: 4.1.0

Parameters

Prepares a given class for observable instances. ...

Prepares a given class for observable instances. This method is called when a class derives from this class or uses this class as a mixin.

Available since: 4.1.0

Parameters

  • T : Function

    The class constructor to prepare.

( success, operation, request, response, callback, scope )private
Should this be documented as protected method? ...

Should this be documented as protected method?

Available since: 4.0.0

Parameters

( operation, callback, scope )
Performs the given read operation. ...

Performs the given read operation.

Available since: 4.0.0

Parameters

  • operation : Ext.data.Operation

    The Operation to perform

  • callback : Function

    Callback function to be called when the Operation has completed (whether successful or not)

  • scope : Object

    Scope to execute the callback function in

Overrides: Ext.data.proxy.Proxy.read

Relays selected events from the specified Observable as if the events were fired by this. ...

Relays selected events from the specified Observable as if the events were fired by this.

For example if you are extending Grid, you might decide to forward some events from store. So you can do this inside your initComponent:

this.relayEvents(this.getStore(), ['load']);

The grid instance will then have an observable 'load' event which will be passed the parameters of the store's load event and any function fired with the grid's load event would have access to the grid using the this keyword.

Available since: 2.3.0

Parameters

  • origin : Object

    The Observable whose events this object is to relay.

  • events : String[]

    Array of event names to relay.

  • prefix : String (optional)

    A common prefix to prepend to the event names. For example:

    this.relayEvents(this.getStore(), ['load', 'clear'], 'store');
    

    Now the grid will forward 'load' and 'clear' events of store as 'storeload' and 'storeclear'.

Returns

  • Object

    A Destroyable object. An object which implements the destroy method which, when destroyed, removes all relayers. For example:

    this.storeRelayers = this.relayEvents(this.getStore(), ['load', 'clear'], 'store');
    

    Can be undone by calling

    Ext.destroy(this.storeRelayers);
    

    or

    this.store.relayers.destroy();
    
Removes an event handler. ...

Removes an event handler.

Available since: 1.1.0

Parameters

  • eventName : String

    The type of event the handler was associated with.

  • fn : Function

    The handler to remove. This must be a reference to the function passed into the addListener call.

  • scope : Object (optional)

    The scope originally specified for the handler. It must be the same as the scope argument specified in the original call to addListener or the listener will not be removed.

Removes listeners that were added by the mon method. ...

Removes listeners that were added by the mon method.

Available since: 4.0.0

Parameters

  • item : Ext.util.Observable/Ext.Element

    The item from which to remove a listener/listeners.

  • ename : Object/String

    The event name, or an object containing event name properties.

  • fn : Function (optional)

    If the ename parameter was an event name, this is the handler function.

  • scope : Object (optional)

    If the ename parameter was an event name, this is the scope (this reference) in which the handler function is executed.

Remove a single managed listener item ...

Remove a single managed listener item

Available since: 4.0.1

Parameters

  • isClear : Boolean

    True if this is being called during a clear

  • managedListener : Object

    The managed listener item See removeManagedListener for other args

Overrides: Ext.AbstractComponent.removeManagedListenerItem

Resumes firing events (see suspendEvents). ...

Resumes firing events (see suspendEvents).

If events were suspended using the queueSuspended parameter, then all events fired during event suspension will be sent to any listeners now.

Available since: 2.3.0

( config, applyIfNotSet ) : Ext.Basechainableprivate
...

Available since: 4.0.0

Parameters

Returns

( operation, response )private
Sets up an exception on the operation ...

Sets up an exception on the operation

Available since: 4.0.0

Parameters

Sets a value in the underlying extraParams. ...

Sets a value in the underlying extraParams.

Available since: 4.1.0

Parameters

  • name : String

    The key for the new value

  • value : Object

    The value

Sets the model associated with this proxy. ...

Sets the model associated with this proxy. This will only usually be called by a Store

Available since: 4.0.0

Parameters

  • model : String/Ext.data.Model

    The new model. Can be either the model name string, or a reference to the model's constructor

  • setOnStore : Boolean

    Sets the new model on the associated Store, if one is present

Sets the Proxy's Reader by string, config object or Reader instance ...

Sets the Proxy's Reader by string, config object or Reader instance

Available since: 4.0.0

Parameters

Returns

Sets the Proxy's Writer by string, config object or Writer instance ...

Sets the Proxy's Writer by string, config object or Writer instance

Available since: 4.0.0

Parameters

Returns

Get the reference to the class from which this object was instantiated. ...

Get the reference to the class from which this object was instantiated. Note that unlike self, this.statics() is scope-independent and it always returns the class from which it was called, regardless of what this points to during run-time

Ext.define('My.Cat', {
    statics: {
        totalCreated: 0,
        speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
    },

    constructor: function() {
        var statics = this.statics();

        alert(statics.speciesName);     // always equals to 'Cat' no matter what 'this' refers to
                                        // equivalent to: My.Cat.speciesName

        alert(this.self.speciesName);   // dependent on 'this'

        statics.totalCreated++;
    },

    clone: function() {
        var cloned = new this.self;                      // dependent on 'this'

        cloned.groupName = this.statics().speciesName;   // equivalent to: My.Cat.speciesName

        return cloned;
    }
});


Ext.define('My.SnowLeopard', {
    extend: 'My.Cat',

    statics: {
        speciesName: 'Snow Leopard'     // My.SnowLeopard.speciesName = 'Snow Leopard'
    },

    constructor: function() {
        this.callParent();
    }
});

var cat = new My.Cat();                 // alerts 'Cat', then alerts 'Cat'

var snowLeopard = new My.SnowLeopard(); // alerts 'Cat', then alerts 'Snow Leopard'

var clone = snowLeopard.clone();
alert(Ext.getClassName(clone));         // alerts 'My.SnowLeopard'
alert(clone.groupName);                 // alerts 'Cat'

alert(My.Cat.totalCreated);             // alerts 3

Available since: 4.0.0

Returns

Suspends the firing of all events. ...

Suspends the firing of all events. (see resumeEvents)

Available since: 2.3.0

Parameters

  • queueSuspended : Boolean

    Pass as true to queue up suspended events to be fired after the resumeEvents call instead of discarding all suspended events.

( eventName, fn, [scope] )
Shorthand for removeListener. ...

Shorthand for removeListener.

Removes an event handler.

Available since: 1.1.0

Parameters

  • eventName : String

    The type of event the handler was associated with.

  • fn : Function

    The handler to remove. This must be a reference to the function passed into the addListener call.

  • scope : Object (optional)

    The scope originally specified for the handler. It must be the same as the scope argument specified in the original call to addListener or the listener will not be removed.

( operation, callback, scope )
Performs the given update operation. ...

Performs the given update operation.

Available since: 4.0.0

Parameters

  • operation : Ext.data.Operation

    The Operation to perform

  • callback : Function

    Callback function to be called when the Operation has completed (whether successful or not)

  • scope : Object

    Scope to execute the callback function in

Overrides: Ext.data.proxy.Proxy.update

Defined By

Static Methods

( config )privatestatic
...

Available since: 4.1.1

Parameters

( members )chainableprivatestatic
...

Available since: 4.1.1

Parameters

( name, member )chainableprivatestatic
...

Available since: 4.1.1

Parameters

( members )chainablestatic
Add methods / properties to the prototype of this class. ...

Add methods / properties to the prototype of this class.

Ext.define('My.awesome.Cat', {
    constructor: function() {
        ...
    }
});

 My.awesome.Cat.addMembers({
     meow: function() {
        alert('Meowww...');
     }
 });

 var kitty = new My.awesome.Cat;
 kitty.meow();

Available since: 4.1.0

Parameters

( members ) : Ext.Basechainablestatic
Add / override static properties of this class. ...

Add / override static properties of this class.

Ext.define('My.cool.Class', {
    ...
});

My.cool.Class.addStatics({
    someProperty: 'someValue',      // My.cool.Class.someProperty = 'someValue'
    method1: function() { ... },    // My.cool.Class.method1 = function() { ... };
    method2: function() { ... }     // My.cool.Class.method2 = function() { ... };
});

Available since: 4.0.2

Parameters

Returns

( xtype )chainableprivatestatic
...

Available since: 4.1.1

Parameters

( fromClass, members ) : Ext.Basechainableprivatestatic
Borrow another class' members to the prototype of this class. ...

Borrow another class' members to the prototype of this class.

Ext.define('Bank', {
    money: '$$$',
    printMoney: function() {
        alert('$$$$$$$');
    }
});

Ext.define('Thief', {
    ...
});

Thief.borrow(Bank, ['money', 'printMoney']);

var steve = new Thief();

alert(steve.money); // alerts '$$$'
steve.printMoney(); // alerts '$$$$$$$'

Available since: 4.0.2

Parameters

  • fromClass : Ext.Base

    The class to borrow members from

  • members : Array/String

    The names of the members to borrow

Returns

Create a new instance of this Class. ...

Create a new instance of this Class.

Ext.define('My.cool.Class', {
    ...
});

My.cool.Class.create({
    someConfig: true
});

All parameters are passed to the constructor of the class.

Available since: 4.0.2

Returns

( alias, origin )static
Create aliases for existing prototype methods. ...

Create aliases for existing prototype methods. Example:

Ext.define('My.cool.Class', {
    method1: function() { ... },
    method2: function() { ... }
});

var test = new My.cool.Class();

My.cool.Class.createAlias({
    method3: 'method1',
    method4: 'method2'
});

test.method3(); // test.method1()

My.cool.Class.createAlias('method5', 'method3');

test.method5(); // test.method3() -> test.method1()

Available since: 4.0.2

Parameters

( config )privatestatic
...

Available since: 4.1.1

Parameters

Get the current class' name in string format. ...

Get the current class' name in string format.

Ext.define('My.cool.Class', {
    constructor: function() {
        alert(this.self.getName()); // alerts 'My.cool.Class'
    }
});

My.cool.Class.getName(); // 'My.cool.Class'

Available since: 4.0.4

Returns

( )deprecatedstatic
Adds members to class. ...

Adds members to class.

This method has been deprecated since 4.1

Use addMembers instead.

Available since: 4.0.2

( name, mixinClass )chainableprivatestatic
Used internally by the mixins pre-processor ...

Used internally by the mixins pre-processor

Available since: 4.1.1

Parameters

( fn, scope )chainableprivatestatic
...

Available since: 4.1.1

Parameters

( members ) : Ext.Basechainabledeprecatedstatic
Override members of this class. ...

Override members of this class. Overridden methods can be invoked via callParent.

Ext.define('My.Cat', {
    constructor: function() {
        alert("I'm a cat!");
    }
});

My.Cat.override({
    constructor: function() {
        alert("I'm going to be a cat!");

        this.callParent(arguments);

        alert("Meeeeoooowwww");
    }
});

var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
                          // alerts "I'm a cat!"
                          // alerts "Meeeeoooowwww"

As of 4.1, direct use of this method is deprecated. Use Ext.define instead:

Ext.define('My.CatOverride', {
    override: 'My.Cat',
    constructor: function() {
        alert("I'm going to be a cat!");

        this.callParent(arguments);

        alert("Meeeeoooowwww");
    }
});

The above accomplishes the same result but can be managed by the Ext.Loader which can properly order the override and its target class and the build process can determine whether the override is needed based on the required state of the target class (My.Cat).

This method has been deprecated since 4.1.0

Use Ext.define instead

Available since: 4.0.2

Parameters

  • members : Object

    The properties to add to this class. This should be specified as an object literal containing one or more properties.

Returns

...

Available since: 4.1.1

Defined By

Events

( this, response, operation, eOpts )
Fires when the server returns an exception. ...

Fires when the server returns an exception. This event may also be listened to in the event that a request has timed out or has been aborted.

Available since: 4.0.0

Parameters

Fires when this proxy's reader provides new metadata. ...

Fires when this proxy's reader provides new metadata. Metadata usually consists of new field definitions, but can include any configuration data required by an application, and can be processed as needed in the event handler. This event is currently only fired for JsonReaders. Note that this event is also propagated by Ext.data.Store, which is typically where it would be handled.

Available since: 4.1.0

Parameters